"""Dataclasses for all structs in the HyperdriveFactoryTest contract.

DO NOT EDIT.  This file was generated by pypechain v0.0.46.
See documentation at https://github.com/delvtech/pypechain """

# super() call methods are generic, while our version adds values & types
# pylint: disable=arguments-differ

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# unable to determine which imports will be used in the generated code
# pylint: disable=unused-import

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# We import this contract itself to ensure all nested structs have a fully qualified name.
# We use this to avoid namespace collisions, as well as having a uniform
# type structure to do lookups when functions return these structs.
# pylint: disable=import-self


from __future__ import annotations

from dataclasses import dataclass

from pypechain.core import BaseEvent, BaseEventArgs, ErrorInfo


@dataclass(kw_only=True)
class AddLiquidityEvent(BaseEvent):
    """The event type for event AddLiquidity"""

    @dataclass(kw_only=True)
    class AddLiquidityEventArgs(BaseEventArgs):
        """The args to the event AddLiquidity"""

        provider: str
        lpAmount: int
        amount: int
        vaultSharePrice: int
        asBase: bool
        lpSharePrice: int
        extraData: bytes

    # We redefine the args field with the specific event arg type.
    args: AddLiquidityEventArgs  # type: ignore[override]

    __name__: str = "AddLiquidity"


@dataclass(kw_only=True)
class ApprovalEvent(BaseEvent):
    """The event type for event Approval"""

    @dataclass(kw_only=True)
    class ApprovalEventArgs(BaseEventArgs):
        """The args to the event Approval"""

        owner: str
        spender: str
        value: int

    # We redefine the args field with the specific event arg type.
    args: ApprovalEventArgs  # type: ignore[override]

    __name__: str = "Approval"


@dataclass(kw_only=True)
class ApprovalForAllEvent(BaseEvent):
    """The event type for event ApprovalForAll"""

    @dataclass(kw_only=True)
    class ApprovalForAllEventArgs(BaseEventArgs):
        """The args to the event ApprovalForAll"""

        account: str
        operator: str
        approved: bool

    # We redefine the args field with the specific event arg type.
    args: ApprovalForAllEventArgs  # type: ignore[override]

    __name__: str = "ApprovalForAll"


@dataclass(kw_only=True)
class CheckpointDurationResolutionUpdatedEvent(BaseEvent):
    """The event type for event CheckpointDurationResolutionUpdated"""

    @dataclass(kw_only=True)
    class CheckpointDurationResolutionUpdatedEventArgs(BaseEventArgs):
        """The args to the event CheckpointDurationResolutionUpdated"""

        newCheckpointDurationResolution: int

    # We redefine the args field with the specific event arg type.
    args: CheckpointDurationResolutionUpdatedEventArgs  # type: ignore[override]

    __name__: str = "CheckpointDurationResolutionUpdated"


@dataclass(kw_only=True)
class CloseLongEvent(BaseEvent):
    """The event type for event CloseLong"""

    @dataclass(kw_only=True)
    class CloseLongEventArgs(BaseEventArgs):
        """The args to the event CloseLong"""

        trader: str
        destination: str
        assetId: int
        maturityTime: int
        amount: int
        vaultSharePrice: int
        asBase: bool
        bondAmount: int
        extraData: bytes

    # We redefine the args field with the specific event arg type.
    args: CloseLongEventArgs  # type: ignore[override]

    __name__: str = "CloseLong"


@dataclass(kw_only=True)
class CloseShortEvent(BaseEvent):
    """The event type for event CloseShort"""

    @dataclass(kw_only=True)
    class CloseShortEventArgs(BaseEventArgs):
        """The args to the event CloseShort"""

        trader: str
        destination: str
        assetId: int
        maturityTime: int
        amount: int
        vaultSharePrice: int
        asBase: bool
        basePayment: int
        bondAmount: int
        extraData: bytes

    # We redefine the args field with the specific event arg type.
    args: CloseShortEventArgs  # type: ignore[override]

    __name__: str = "CloseShort"


@dataclass(kw_only=True)
class CollectGovernanceFeeEvent(BaseEvent):
    """The event type for event CollectGovernanceFee"""

    @dataclass(kw_only=True)
    class CollectGovernanceFeeEventArgs(BaseEventArgs):
        """The args to the event CollectGovernanceFee"""

        collector: str
        amount: int
        vaultSharePrice: int
        asBase: bool

    # We redefine the args field with the specific event arg type.
    args: CollectGovernanceFeeEventArgs  # type: ignore[override]

    __name__: str = "CollectGovernanceFee"


@dataclass(kw_only=True)
class CreateCheckpointEvent(BaseEvent):
    """The event type for event CreateCheckpoint"""

    @dataclass(kw_only=True)
    class CreateCheckpointEventArgs(BaseEventArgs):
        """The args to the event CreateCheckpoint"""

        checkpointTime: int
        checkpointVaultSharePrice: int
        vaultSharePrice: int
        maturedShorts: int
        maturedLongs: int
        lpSharePrice: int

    # We redefine the args field with the specific event arg type.
    args: CreateCheckpointEventArgs  # type: ignore[override]

    __name__: str = "CreateCheckpoint"


@dataclass(kw_only=True)
class DefaultPausersUpdatedEvent(BaseEvent):
    """The event type for event DefaultPausersUpdated"""

    @dataclass(kw_only=True)
    class DefaultPausersUpdatedEventArgs(BaseEventArgs):
        """The args to the event DefaultPausersUpdated"""

        newDefaultPausers: list[str]

    # We redefine the args field with the specific event arg type.
    args: DefaultPausersUpdatedEventArgs  # type: ignore[override]

    __name__: str = "DefaultPausersUpdated"


@dataclass(kw_only=True)
class DeployedEvent(BaseEvent):
    """The event type for event Deployed"""

    @dataclass(kw_only=True)
    class DeployedEventArgs(BaseEventArgs):
        """The args to the event Deployed"""

        deployerCoordinator: str
        hyperdrive: str
        name: str
        config: tuple
        extraData: bytes

    # We redefine the args field with the specific event arg type.
    args: DeployedEventArgs  # type: ignore[override]

    __name__: str = "Deployed"


@dataclass(kw_only=True)
class DeployerCoordinatorAddedEvent(BaseEvent):
    """The event type for event DeployerCoordinatorAdded"""

    @dataclass(kw_only=True)
    class DeployerCoordinatorAddedEventArgs(BaseEventArgs):
        """The args to the event DeployerCoordinatorAdded"""

        deployerCoordinator: str

    # We redefine the args field with the specific event arg type.
    args: DeployerCoordinatorAddedEventArgs  # type: ignore[override]

    __name__: str = "DeployerCoordinatorAdded"


@dataclass(kw_only=True)
class DeployerCoordinatorManagerUpdatedEvent(BaseEvent):
    """The event type for event DeployerCoordinatorManagerUpdated"""

    @dataclass(kw_only=True)
    class DeployerCoordinatorManagerUpdatedEventArgs(BaseEventArgs):
        """The args to the event DeployerCoordinatorManagerUpdated"""

        deployerCoordinatorManager: str

    # We redefine the args field with the specific event arg type.
    args: DeployerCoordinatorManagerUpdatedEventArgs  # type: ignore[override]

    __name__: str = "DeployerCoordinatorManagerUpdated"


@dataclass(kw_only=True)
class DeployerCoordinatorRemovedEvent(BaseEvent):
    """The event type for event DeployerCoordinatorRemoved"""

    @dataclass(kw_only=True)
    class DeployerCoordinatorRemovedEventArgs(BaseEventArgs):
        """The args to the event DeployerCoordinatorRemoved"""

        deployerCoordinator: str

    # We redefine the args field with the specific event arg type.
    args: DeployerCoordinatorRemovedEventArgs  # type: ignore[override]

    __name__: str = "DeployerCoordinatorRemoved"


@dataclass(kw_only=True)
class FeeCollectorUpdatedEvent(BaseEvent):
    """The event type for event FeeCollectorUpdated"""

    @dataclass(kw_only=True)
    class FeeCollectorUpdatedEventArgs(BaseEventArgs):
        """The args to the event FeeCollectorUpdated"""

        feeCollector: str

    # We redefine the args field with the specific event arg type.
    args: FeeCollectorUpdatedEventArgs  # type: ignore[override]

    __name__: str = "FeeCollectorUpdated"


@dataclass(kw_only=True)
class GovernanceUpdatedEvent(BaseEvent):
    """The event type for event GovernanceUpdated"""

    @dataclass(kw_only=True)
    class GovernanceUpdatedEventArgs(BaseEventArgs):
        """The args to the event GovernanceUpdated"""

        governance: str

    # We redefine the args field with the specific event arg type.
    args: GovernanceUpdatedEventArgs  # type: ignore[override]

    __name__: str = "GovernanceUpdated"


@dataclass(kw_only=True)
class HyperdriveGovernanceUpdatedEvent(BaseEvent):
    """The event type for event HyperdriveGovernanceUpdated"""

    @dataclass(kw_only=True)
    class HyperdriveGovernanceUpdatedEventArgs(BaseEventArgs):
        """The args to the event HyperdriveGovernanceUpdated"""

        hyperdriveGovernance: str

    # We redefine the args field with the specific event arg type.
    args: HyperdriveGovernanceUpdatedEventArgs  # type: ignore[override]

    __name__: str = "HyperdriveGovernanceUpdated"


@dataclass(kw_only=True)
class InitializeEvent(BaseEvent):
    """The event type for event Initialize"""

    @dataclass(kw_only=True)
    class InitializeEventArgs(BaseEventArgs):
        """The args to the event Initialize"""

        provider: str
        lpAmount: int
        amount: int
        vaultSharePrice: int
        asBase: bool
        apr: int
        extraData: bytes

    # We redefine the args field with the specific event arg type.
    args: InitializeEventArgs  # type: ignore[override]

    __name__: str = "Initialize"


@dataclass(kw_only=True)
class LinkerCodeHashUpdatedEvent(BaseEvent):
    """The event type for event LinkerCodeHashUpdated"""

    @dataclass(kw_only=True)
    class LinkerCodeHashUpdatedEventArgs(BaseEventArgs):
        """The args to the event LinkerCodeHashUpdated"""

        newLinkerCodeHash: bytes

    # We redefine the args field with the specific event arg type.
    args: LinkerCodeHashUpdatedEventArgs  # type: ignore[override]

    __name__: str = "LinkerCodeHashUpdated"


@dataclass(kw_only=True)
class LinkerFactoryUpdatedEvent(BaseEvent):
    """The event type for event LinkerFactoryUpdated"""

    @dataclass(kw_only=True)
    class LinkerFactoryUpdatedEventArgs(BaseEventArgs):
        """The args to the event LinkerFactoryUpdated"""

        newLinkerFactory: str

    # We redefine the args field with the specific event arg type.
    args: LinkerFactoryUpdatedEventArgs  # type: ignore[override]

    __name__: str = "LinkerFactoryUpdated"


@dataclass(kw_only=True)
class MaxCheckpointDurationUpdatedEvent(BaseEvent):
    """The event type for event MaxCheckpointDurationUpdated"""

    @dataclass(kw_only=True)
    class MaxCheckpointDurationUpdatedEventArgs(BaseEventArgs):
        """The args to the event MaxCheckpointDurationUpdated"""

        newMaxCheckpointDuration: int

    # We redefine the args field with the specific event arg type.
    args: MaxCheckpointDurationUpdatedEventArgs  # type: ignore[override]

    __name__: str = "MaxCheckpointDurationUpdated"


@dataclass(kw_only=True)
class MaxCircuitBreakerDeltaUpdatedEvent(BaseEvent):
    """The event type for event MaxCircuitBreakerDeltaUpdated"""

    @dataclass(kw_only=True)
    class MaxCircuitBreakerDeltaUpdatedEventArgs(BaseEventArgs):
        """The args to the event MaxCircuitBreakerDeltaUpdated"""

        newMaxCircuitBreakerDelta: int

    # We redefine the args field with the specific event arg type.
    args: MaxCircuitBreakerDeltaUpdatedEventArgs  # type: ignore[override]

    __name__: str = "MaxCircuitBreakerDeltaUpdated"


@dataclass(kw_only=True)
class MaxFeesUpdatedEvent(BaseEvent):
    """The event type for event MaxFeesUpdated"""

    @dataclass(kw_only=True)
    class MaxFeesUpdatedEventArgs(BaseEventArgs):
        """The args to the event MaxFeesUpdated"""

        newMaxFees: tuple

    # We redefine the args field with the specific event arg type.
    args: MaxFeesUpdatedEventArgs  # type: ignore[override]

    __name__: str = "MaxFeesUpdated"


@dataclass(kw_only=True)
class MaxFixedAPRUpdatedEvent(BaseEvent):
    """The event type for event MaxFixedAPRUpdated"""

    @dataclass(kw_only=True)
    class MaxFixedAPRUpdatedEventArgs(BaseEventArgs):
        """The args to the event MaxFixedAPRUpdated"""

        newMaxFixedAPR: int

    # We redefine the args field with the specific event arg type.
    args: MaxFixedAPRUpdatedEventArgs  # type: ignore[override]

    __name__: str = "MaxFixedAPRUpdated"


@dataclass(kw_only=True)
class MaxPositionDurationUpdatedEvent(BaseEvent):
    """The event type for event MaxPositionDurationUpdated"""

    @dataclass(kw_only=True)
    class MaxPositionDurationUpdatedEventArgs(BaseEventArgs):
        """The args to the event MaxPositionDurationUpdated"""

        newMaxPositionDuration: int

    # We redefine the args field with the specific event arg type.
    args: MaxPositionDurationUpdatedEventArgs  # type: ignore[override]

    __name__: str = "MaxPositionDurationUpdated"


@dataclass(kw_only=True)
class MaxTimeStretchAPRUpdatedEvent(BaseEvent):
    """The event type for event MaxTimeStretchAPRUpdated"""

    @dataclass(kw_only=True)
    class MaxTimeStretchAPRUpdatedEventArgs(BaseEventArgs):
        """The args to the event MaxTimeStretchAPRUpdated"""

        newMaxTimeStretchAPR: int

    # We redefine the args field with the specific event arg type.
    args: MaxTimeStretchAPRUpdatedEventArgs  # type: ignore[override]

    __name__: str = "MaxTimeStretchAPRUpdated"


@dataclass(kw_only=True)
class MinCheckpointDurationUpdatedEvent(BaseEvent):
    """The event type for event MinCheckpointDurationUpdated"""

    @dataclass(kw_only=True)
    class MinCheckpointDurationUpdatedEventArgs(BaseEventArgs):
        """The args to the event MinCheckpointDurationUpdated"""

        newMinCheckpointDuration: int

    # We redefine the args field with the specific event arg type.
    args: MinCheckpointDurationUpdatedEventArgs  # type: ignore[override]

    __name__: str = "MinCheckpointDurationUpdated"


@dataclass(kw_only=True)
class MinCircuitBreakerDeltaUpdatedEvent(BaseEvent):
    """The event type for event MinCircuitBreakerDeltaUpdated"""

    @dataclass(kw_only=True)
    class MinCircuitBreakerDeltaUpdatedEventArgs(BaseEventArgs):
        """The args to the event MinCircuitBreakerDeltaUpdated"""

        newMinCircuitBreakerDelta: int

    # We redefine the args field with the specific event arg type.
    args: MinCircuitBreakerDeltaUpdatedEventArgs  # type: ignore[override]

    __name__: str = "MinCircuitBreakerDeltaUpdated"


@dataclass(kw_only=True)
class MinFeesUpdatedEvent(BaseEvent):
    """The event type for event MinFeesUpdated"""

    @dataclass(kw_only=True)
    class MinFeesUpdatedEventArgs(BaseEventArgs):
        """The args to the event MinFeesUpdated"""

        newMinFees: tuple

    # We redefine the args field with the specific event arg type.
    args: MinFeesUpdatedEventArgs  # type: ignore[override]

    __name__: str = "MinFeesUpdated"


@dataclass(kw_only=True)
class MinFixedAPRUpdatedEvent(BaseEvent):
    """The event type for event MinFixedAPRUpdated"""

    @dataclass(kw_only=True)
    class MinFixedAPRUpdatedEventArgs(BaseEventArgs):
        """The args to the event MinFixedAPRUpdated"""

        newMinFixedAPR: int

    # We redefine the args field with the specific event arg type.
    args: MinFixedAPRUpdatedEventArgs  # type: ignore[override]

    __name__: str = "MinFixedAPRUpdated"


@dataclass(kw_only=True)
class MinPositionDurationUpdatedEvent(BaseEvent):
    """The event type for event MinPositionDurationUpdated"""

    @dataclass(kw_only=True)
    class MinPositionDurationUpdatedEventArgs(BaseEventArgs):
        """The args to the event MinPositionDurationUpdated"""

        newMinPositionDuration: int

    # We redefine the args field with the specific event arg type.
    args: MinPositionDurationUpdatedEventArgs  # type: ignore[override]

    __name__: str = "MinPositionDurationUpdated"


@dataclass(kw_only=True)
class MinTimeStretchAPRUpdatedEvent(BaseEvent):
    """The event type for event MinTimeStretchAPRUpdated"""

    @dataclass(kw_only=True)
    class MinTimeStretchAPRUpdatedEventArgs(BaseEventArgs):
        """The args to the event MinTimeStretchAPRUpdated"""

        newMinTimeStretchAPR: int

    # We redefine the args field with the specific event arg type.
    args: MinTimeStretchAPRUpdatedEventArgs  # type: ignore[override]

    __name__: str = "MinTimeStretchAPRUpdated"


@dataclass(kw_only=True)
class OpenLongEvent(BaseEvent):
    """The event type for event OpenLong"""

    @dataclass(kw_only=True)
    class OpenLongEventArgs(BaseEventArgs):
        """The args to the event OpenLong"""

        trader: str
        assetId: int
        maturityTime: int
        amount: int
        vaultSharePrice: int
        asBase: bool
        bondAmount: int
        extraData: bytes

    # We redefine the args field with the specific event arg type.
    args: OpenLongEventArgs  # type: ignore[override]

    __name__: str = "OpenLong"


@dataclass(kw_only=True)
class OpenShortEvent(BaseEvent):
    """The event type for event OpenShort"""

    @dataclass(kw_only=True)
    class OpenShortEventArgs(BaseEventArgs):
        """The args to the event OpenShort"""

        trader: str
        assetId: int
        maturityTime: int
        amount: int
        vaultSharePrice: int
        asBase: bool
        baseProceeds: int
        bondAmount: int
        extraData: bytes

    # We redefine the args field with the specific event arg type.
    args: OpenShortEventArgs  # type: ignore[override]

    __name__: str = "OpenShort"


@dataclass(kw_only=True)
class PauseStatusUpdatedEvent(BaseEvent):
    """The event type for event PauseStatusUpdated"""

    @dataclass(kw_only=True)
    class PauseStatusUpdatedEventArgs(BaseEventArgs):
        """The args to the event PauseStatusUpdated"""

        isPaused: bool

    # We redefine the args field with the specific event arg type.
    args: PauseStatusUpdatedEventArgs  # type: ignore[override]

    __name__: str = "PauseStatusUpdated"


@dataclass(kw_only=True)
class RedeemWithdrawalSharesEvent(BaseEvent):
    """The event type for event RedeemWithdrawalShares"""

    @dataclass(kw_only=True)
    class RedeemWithdrawalSharesEventArgs(BaseEventArgs):
        """The args to the event RedeemWithdrawalShares"""

        provider: str
        destination: str
        withdrawalShareAmount: int
        amount: int
        vaultSharePrice: int
        asBase: bool
        extraData: bytes

    # We redefine the args field with the specific event arg type.
    args: RedeemWithdrawalSharesEventArgs  # type: ignore[override]

    __name__: str = "RedeemWithdrawalShares"


@dataclass(kw_only=True)
class RemoveLiquidityEvent(BaseEvent):
    """The event type for event RemoveLiquidity"""

    @dataclass(kw_only=True)
    class RemoveLiquidityEventArgs(BaseEventArgs):
        """The args to the event RemoveLiquidity"""

        provider: str
        destination: str
        lpAmount: int
        amount: int
        vaultSharePrice: int
        asBase: bool
        withdrawalShareAmount: int
        lpSharePrice: int
        extraData: bytes

    # We redefine the args field with the specific event arg type.
    args: RemoveLiquidityEventArgs  # type: ignore[override]

    __name__: str = "RemoveLiquidity"


@dataclass(kw_only=True)
class SweepEvent(BaseEvent):
    """The event type for event Sweep"""

    @dataclass(kw_only=True)
    class SweepEventArgs(BaseEventArgs):
        """The args to the event Sweep"""

        collector: str
        target: str

    # We redefine the args field with the specific event arg type.
    args: SweepEventArgs  # type: ignore[override]

    __name__: str = "Sweep"


@dataclass(kw_only=True)
class SweepCollectorUpdatedEvent(BaseEvent):
    """The event type for event SweepCollectorUpdated"""

    @dataclass(kw_only=True)
    class SweepCollectorUpdatedEventArgs(BaseEventArgs):
        """The args to the event SweepCollectorUpdated"""

        sweepCollector: str

    # We redefine the args field with the specific event arg type.
    args: SweepCollectorUpdatedEventArgs  # type: ignore[override]

    __name__: str = "SweepCollectorUpdated"


@dataclass(kw_only=True)
class TransferSingleEvent(BaseEvent):
    """The event type for event TransferSingle"""

    @dataclass(kw_only=True)
    class TransferSingleEventArgs(BaseEventArgs):
        """The args to the event TransferSingle"""

        operator: str
        _from: str
        to: str
        _id: int
        value: int

    # We redefine the args field with the specific event arg type.
    args: TransferSingleEventArgs  # type: ignore[override]

    __name__: str = "TransferSingle"


@dataclass(kw_only=True)
class LogEvent(BaseEvent):
    """The event type for event log"""

    @dataclass(kw_only=True)
    class LogEventArgs(BaseEventArgs):
        """The args to the event log"""

        arg1: str

    # We redefine the args field with the specific event arg type.
    args: LogEventArgs  # type: ignore[override]

    __name__: str = "log"


@dataclass(kw_only=True)
class Log_addressEvent(BaseEvent):
    """The event type for event log_address"""

    @dataclass(kw_only=True)
    class Log_addressEventArgs(BaseEventArgs):
        """The args to the event log_address"""

        arg1: str

    # We redefine the args field with the specific event arg type.
    args: Log_addressEventArgs  # type: ignore[override]

    __name__: str = "log_address"


@dataclass(kw_only=True)
class Log_arrayEvent(BaseEvent):
    """The event type for event log_array"""

    @dataclass(kw_only=True)
    class Log_arrayEventArgs(BaseEventArgs):
        """The args to the event log_array"""

        val: list[str]

    # We redefine the args field with the specific event arg type.
    args: Log_arrayEventArgs  # type: ignore[override]

    __name__: str = "log_array"


@dataclass(kw_only=True)
class Log_bytesEvent(BaseEvent):
    """The event type for event log_bytes"""

    @dataclass(kw_only=True)
    class Log_bytesEventArgs(BaseEventArgs):
        """The args to the event log_bytes"""

        arg1: bytes

    # We redefine the args field with the specific event arg type.
    args: Log_bytesEventArgs  # type: ignore[override]

    __name__: str = "log_bytes"


@dataclass(kw_only=True)
class Log_bytes32Event(BaseEvent):
    """The event type for event log_bytes32"""

    @dataclass(kw_only=True)
    class Log_bytes32EventArgs(BaseEventArgs):
        """The args to the event log_bytes32"""

        arg1: bytes

    # We redefine the args field with the specific event arg type.
    args: Log_bytes32EventArgs  # type: ignore[override]

    __name__: str = "log_bytes32"


@dataclass(kw_only=True)
class Log_intEvent(BaseEvent):
    """The event type for event log_int"""

    @dataclass(kw_only=True)
    class Log_intEventArgs(BaseEventArgs):
        """The args to the event log_int"""

        arg1: int

    # We redefine the args field with the specific event arg type.
    args: Log_intEventArgs  # type: ignore[override]

    __name__: str = "log_int"


@dataclass(kw_only=True)
class Log_named_addressEvent(BaseEvent):
    """The event type for event log_named_address"""

    @dataclass(kw_only=True)
    class Log_named_addressEventArgs(BaseEventArgs):
        """The args to the event log_named_address"""

        key: str
        val: str

    # We redefine the args field with the specific event arg type.
    args: Log_named_addressEventArgs  # type: ignore[override]

    __name__: str = "log_named_address"


@dataclass(kw_only=True)
class Log_named_arrayEvent(BaseEvent):
    """The event type for event log_named_array"""

    @dataclass(kw_only=True)
    class Log_named_arrayEventArgs(BaseEventArgs):
        """The args to the event log_named_array"""

        key: str
        val: list[str]

    # We redefine the args field with the specific event arg type.
    args: Log_named_arrayEventArgs  # type: ignore[override]

    __name__: str = "log_named_array"


@dataclass(kw_only=True)
class Log_named_bytesEvent(BaseEvent):
    """The event type for event log_named_bytes"""

    @dataclass(kw_only=True)
    class Log_named_bytesEventArgs(BaseEventArgs):
        """The args to the event log_named_bytes"""

        key: str
        val: bytes

    # We redefine the args field with the specific event arg type.
    args: Log_named_bytesEventArgs  # type: ignore[override]

    __name__: str = "log_named_bytes"


@dataclass(kw_only=True)
class Log_named_bytes32Event(BaseEvent):
    """The event type for event log_named_bytes32"""

    @dataclass(kw_only=True)
    class Log_named_bytes32EventArgs(BaseEventArgs):
        """The args to the event log_named_bytes32"""

        key: str
        val: bytes

    # We redefine the args field with the specific event arg type.
    args: Log_named_bytes32EventArgs  # type: ignore[override]

    __name__: str = "log_named_bytes32"


@dataclass(kw_only=True)
class Log_named_decimal_intEvent(BaseEvent):
    """The event type for event log_named_decimal_int"""

    @dataclass(kw_only=True)
    class Log_named_decimal_intEventArgs(BaseEventArgs):
        """The args to the event log_named_decimal_int"""

        key: str
        val: int
        decimals: int

    # We redefine the args field with the specific event arg type.
    args: Log_named_decimal_intEventArgs  # type: ignore[override]

    __name__: str = "log_named_decimal_int"


@dataclass(kw_only=True)
class Log_named_decimal_uintEvent(BaseEvent):
    """The event type for event log_named_decimal_uint"""

    @dataclass(kw_only=True)
    class Log_named_decimal_uintEventArgs(BaseEventArgs):
        """The args to the event log_named_decimal_uint"""

        key: str
        val: int
        decimals: int

    # We redefine the args field with the specific event arg type.
    args: Log_named_decimal_uintEventArgs  # type: ignore[override]

    __name__: str = "log_named_decimal_uint"


@dataclass(kw_only=True)
class Log_named_intEvent(BaseEvent):
    """The event type for event log_named_int"""

    @dataclass(kw_only=True)
    class Log_named_intEventArgs(BaseEventArgs):
        """The args to the event log_named_int"""

        key: str
        val: int

    # We redefine the args field with the specific event arg type.
    args: Log_named_intEventArgs  # type: ignore[override]

    __name__: str = "log_named_int"


@dataclass(kw_only=True)
class Log_named_stringEvent(BaseEvent):
    """The event type for event log_named_string"""

    @dataclass(kw_only=True)
    class Log_named_stringEventArgs(BaseEventArgs):
        """The args to the event log_named_string"""

        key: str
        val: str

    # We redefine the args field with the specific event arg type.
    args: Log_named_stringEventArgs  # type: ignore[override]

    __name__: str = "log_named_string"


@dataclass(kw_only=True)
class Log_named_uintEvent(BaseEvent):
    """The event type for event log_named_uint"""

    @dataclass(kw_only=True)
    class Log_named_uintEventArgs(BaseEventArgs):
        """The args to the event log_named_uint"""

        key: str
        val: int

    # We redefine the args field with the specific event arg type.
    args: Log_named_uintEventArgs  # type: ignore[override]

    __name__: str = "log_named_uint"


@dataclass(kw_only=True)
class Log_stringEvent(BaseEvent):
    """The event type for event log_string"""

    @dataclass(kw_only=True)
    class Log_stringEventArgs(BaseEventArgs):
        """The args to the event log_string"""

        arg1: str

    # We redefine the args field with the specific event arg type.
    args: Log_stringEventArgs  # type: ignore[override]

    __name__: str = "log_string"


@dataclass(kw_only=True)
class Log_uintEvent(BaseEvent):
    """The event type for event log_uint"""

    @dataclass(kw_only=True)
    class Log_uintEventArgs(BaseEventArgs):
        """The args to the event log_uint"""

        arg1: int

    # We redefine the args field with the specific event arg type.
    args: Log_uintEventArgs  # type: ignore[override]

    __name__: str = "log_uint"


@dataclass(kw_only=True)
class LogsEvent(BaseEvent):
    """The event type for event logs"""

    @dataclass(kw_only=True)
    class LogsEventArgs(BaseEventArgs):
        """The args to the event logs"""

        arg1: bytes

    # We redefine the args field with the specific event arg type.
    args: LogsEventArgs  # type: ignore[override]

    __name__: str = "logs"


LnInvalidInputError = ErrorInfo(
    inputs=[],
    name="LnInvalidInput",
    selector="0xe61b4975",
    signature="LnInvalidInput()",
)

UnsafeCastToInt256Error = ErrorInfo(
    inputs=[],
    name="UnsafeCastToInt256",
    selector="0x72dd4e02",
    signature="UnsafeCastToInt256()",
)

WhaleBalanceExceededError = ErrorInfo(
    inputs=[],
    name="WhaleBalanceExceeded",
    selector="0xc4649d28",
    signature="WhaleBalanceExceeded()",
)

WhaleIsContractError = ErrorInfo(
    inputs=[],
    name="WhaleIsContract",
    selector="0x98d85a67",
    signature="WhaleIsContract()",
)
