"""Dataclasses for all structs in the IAL2Token contract.

DO NOT EDIT.  This file was generated by pypechain v0.0.46.
See documentation at https://github.com/delvtech/pypechain """

# super() call methods are generic, while our version adds values & types
# pylint: disable=arguments-differ

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# unable to determine which imports will be used in the generated code
# pylint: disable=unused-import

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# We import this contract itself to ensure all nested structs have a fully qualified name.
# We use this to avoid namespace collisions, as well as having a uniform
# type structure to do lookups when functions return these structs.
# pylint: disable=import-self


from __future__ import annotations

from dataclasses import dataclass

from pypechain.core import BaseEvent, BaseEventArgs


@dataclass(kw_only=True)
class ApprovalEvent(BaseEvent):
    """The event type for event Approval"""

    @dataclass(kw_only=True)
    class ApprovalEventArgs(BaseEventArgs):
        """The args to the event Approval"""

        owner: str
        spender: str
        value: int

    # We redefine the args field with the specific event arg type.
    args: ApprovalEventArgs  # type: ignore[override]

    __name__: str = "Approval"


@dataclass(kw_only=True)
class BalanceTransferEvent(BaseEvent):
    """The event type for event BalanceTransfer"""

    @dataclass(kw_only=True)
    class BalanceTransferEventArgs(BaseEventArgs):
        """The args to the event BalanceTransfer"""

        _from: str
        to: str
        value: int
        index: int

    # We redefine the args field with the specific event arg type.
    args: BalanceTransferEventArgs  # type: ignore[override]

    __name__: str = "BalanceTransfer"


@dataclass(kw_only=True)
class BurnEvent(BaseEvent):
    """The event type for event Burn"""

    @dataclass(kw_only=True)
    class BurnEventArgs(BaseEventArgs):
        """The args to the event Burn"""

        _from: str
        target: str
        value: int
        balanceIncrease: int
        index: int

    # We redefine the args field with the specific event arg type.
    args: BurnEventArgs  # type: ignore[override]

    __name__: str = "Burn"


@dataclass(kw_only=True)
class InitializedEvent(BaseEvent):
    """The event type for event Initialized"""

    @dataclass(kw_only=True)
    class InitializedEventArgs(BaseEventArgs):
        """The args to the event Initialized"""

        underlyingAsset: str
        pool: str
        treasury: str
        incentivesController: str
        aTokenDecimals: int
        aTokenName: str
        aTokenSymbol: str
        params: bytes

    # We redefine the args field with the specific event arg type.
    args: InitializedEventArgs  # type: ignore[override]

    __name__: str = "Initialized"


@dataclass(kw_only=True)
class MintEvent(BaseEvent):
    """The event type for event Mint"""

    @dataclass(kw_only=True)
    class MintEventArgs(BaseEventArgs):
        """The args to the event Mint"""

        caller: str
        onBehalfOf: str
        value: int
        balanceIncrease: int
        index: int

    # We redefine the args field with the specific event arg type.
    args: MintEventArgs  # type: ignore[override]

    __name__: str = "Mint"


@dataclass(kw_only=True)
class TransferEvent(BaseEvent):
    """The event type for event Transfer"""

    @dataclass(kw_only=True)
    class TransferEventArgs(BaseEventArgs):
        """The args to the event Transfer"""

        _from: str
        to: str
        value: int

    # We redefine the args field with the specific event arg type.
    args: TransferEventArgs  # type: ignore[override]

    __name__: str = "Transfer"
