"""A web3.py Contract class for the IERC721Errors contract.

DO NOT EDIT.  This file was generated by pypechain v0.0.46.
See documentation at https://github.com/delvtech/pypechain """

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# This file is bound to get very long depending on contract sizes.
# pylint: disable=too-many-lines

# methods are overridden with specific arguments instead of generic *args, **kwargs
# pylint: disable=arguments-differ

# consumers have too many opinions on line length
# pylint: disable=line-too-long

# We use protected classes within pypechain
# pylint: disable=protected-access

# We sometimes define a variable that might not be returned in `call`,
# but we still may want to call the function
# pylint: disable=unused-variable


from __future__ import annotations

from typing import Any, Type, cast

from eth_account.signers.local import LocalAccount
from eth_typing import ABI, ChecksumAddress, HexStr
from hexbytes import HexBytes
from pypechain.core import PypechainBaseContractErrors, PypechainBaseError
from typing_extensions import Self
from web3 import Web3
from web3.contract.contract import (
    Contract,
    ContractConstructor,
    ContractFunctions,
)

structs = {}


class IERC721ErrorsContractFunctions(ContractFunctions):
    """ContractFunctions for the IERC721Errors contract."""

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
        decode_tuples: bool | None = False,
    ) -> None:
        super().__init__(abi, w3, address, decode_tuples)


ierc721errors_abi: ABI = cast(
    ABI,
    [
        {
            "type": "error",
            "name": "ERC721IncorrectOwner",
            "inputs": [
                {
                    "name": "sender",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "tokenId",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "owner", "type": "address", "internalType": "address"},
            ],
        },
        {
            "type": "error",
            "name": "ERC721InsufficientApproval",
            "inputs": [
                {
                    "name": "operator",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "tokenId",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
        },
        {
            "type": "error",
            "name": "ERC721InvalidApprover",
            "inputs": [
                {
                    "name": "approver",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC721InvalidOperator",
            "inputs": [
                {
                    "name": "operator",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC721InvalidOwner",
            "inputs": [
                {"name": "owner", "type": "address", "internalType": "address"}
            ],
        },
        {
            "type": "error",
            "name": "ERC721InvalidReceiver",
            "inputs": [
                {
                    "name": "receiver",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC721InvalidSender",
            "inputs": [
                {"name": "sender", "type": "address", "internalType": "address"}
            ],
        },
        {
            "type": "error",
            "name": "ERC721NonexistentToken",
            "inputs": [
                {
                    "name": "tokenId",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
        },
    ],
)


class IERC721ErrorsERC721IncorrectOwnerContractError(PypechainBaseError):
    """ContractError for ERC721IncorrectOwner."""

    # Error name
    name: str = "ERC721IncorrectOwner"
    # 4 byte error selector
    selector: str = "0x64283d7b"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC721IncorrectOwner(address,uint256,address)"
    # Error input types
    abi: ABI = ierc721errors_abi


class IERC721ErrorsERC721InsufficientApprovalContractError(PypechainBaseError):
    """ContractError for ERC721InsufficientApproval."""

    # Error name
    name: str = "ERC721InsufficientApproval"
    # 4 byte error selector
    selector: str = "0x177e802f"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC721InsufficientApproval(address,uint256)"
    # Error input types
    abi: ABI = ierc721errors_abi


class IERC721ErrorsERC721InvalidApproverContractError(PypechainBaseError):
    """ContractError for ERC721InvalidApprover."""

    # Error name
    name: str = "ERC721InvalidApprover"
    # 4 byte error selector
    selector: str = "0xa9fbf51f"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC721InvalidApprover(address)"
    # Error input types
    abi: ABI = ierc721errors_abi


class IERC721ErrorsERC721InvalidOperatorContractError(PypechainBaseError):
    """ContractError for ERC721InvalidOperator."""

    # Error name
    name: str = "ERC721InvalidOperator"
    # 4 byte error selector
    selector: str = "0x5b08ba18"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC721InvalidOperator(address)"
    # Error input types
    abi: ABI = ierc721errors_abi


class IERC721ErrorsERC721InvalidOwnerContractError(PypechainBaseError):
    """ContractError for ERC721InvalidOwner."""

    # Error name
    name: str = "ERC721InvalidOwner"
    # 4 byte error selector
    selector: str = "0x89c62b64"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC721InvalidOwner(address)"
    # Error input types
    abi: ABI = ierc721errors_abi


class IERC721ErrorsERC721InvalidReceiverContractError(PypechainBaseError):
    """ContractError for ERC721InvalidReceiver."""

    # Error name
    name: str = "ERC721InvalidReceiver"
    # 4 byte error selector
    selector: str = "0x64a0ae92"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC721InvalidReceiver(address)"
    # Error input types
    abi: ABI = ierc721errors_abi


class IERC721ErrorsERC721InvalidSenderContractError(PypechainBaseError):
    """ContractError for ERC721InvalidSender."""

    # Error name
    name: str = "ERC721InvalidSender"
    # 4 byte error selector
    selector: str = "0x73c6ac6e"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC721InvalidSender(address)"
    # Error input types
    abi: ABI = ierc721errors_abi


class IERC721ErrorsERC721NonexistentTokenContractError(PypechainBaseError):
    """ContractError for ERC721NonexistentToken."""

    # Error name
    name: str = "ERC721NonexistentToken"
    # 4 byte error selector
    selector: str = "0x7e273289"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC721NonexistentToken(uint256)"
    # Error input types
    abi: ABI = ierc721errors_abi


class IERC721ErrorsContractErrors(PypechainBaseContractErrors):
    """ContractErrors for the IERC721Errors contract."""

    ERC721IncorrectOwner: IERC721ErrorsERC721IncorrectOwnerContractError

    ERC721InsufficientApproval: (
        IERC721ErrorsERC721InsufficientApprovalContractError
    )

    ERC721InvalidApprover: IERC721ErrorsERC721InvalidApproverContractError

    ERC721InvalidOperator: IERC721ErrorsERC721InvalidOperatorContractError

    ERC721InvalidOwner: IERC721ErrorsERC721InvalidOwnerContractError

    ERC721InvalidReceiver: IERC721ErrorsERC721InvalidReceiverContractError

    ERC721InvalidSender: IERC721ErrorsERC721InvalidSenderContractError

    ERC721NonexistentToken: IERC721ErrorsERC721NonexistentTokenContractError

    def __init__(
        self,
    ) -> None:
        self.ERC721IncorrectOwner = (
            IERC721ErrorsERC721IncorrectOwnerContractError()
        )
        self.ERC721InsufficientApproval = (
            IERC721ErrorsERC721InsufficientApprovalContractError()
        )
        self.ERC721InvalidApprover = (
            IERC721ErrorsERC721InvalidApproverContractError()
        )
        self.ERC721InvalidOperator = (
            IERC721ErrorsERC721InvalidOperatorContractError()
        )
        self.ERC721InvalidOwner = IERC721ErrorsERC721InvalidOwnerContractError()
        self.ERC721InvalidReceiver = (
            IERC721ErrorsERC721InvalidReceiverContractError()
        )
        self.ERC721InvalidSender = (
            IERC721ErrorsERC721InvalidSenderContractError()
        )
        self.ERC721NonexistentToken = (
            IERC721ErrorsERC721NonexistentTokenContractError()
        )

        self._all = [
            self.ERC721IncorrectOwner,
            self.ERC721InsufficientApproval,
            self.ERC721InvalidApprover,
            self.ERC721InvalidOperator,
            self.ERC721InvalidOwner,
            self.ERC721InvalidReceiver,
            self.ERC721InvalidSender,
            self.ERC721NonexistentToken,
        ]


class IERC721ErrorsContract(Contract):
    """A web3.py Contract class for the IERC721Errors contract."""

    abi: ABI = ierc721errors_abi
    # We change `bytecode` as needed for linking, but keep
    # `_raw_bytecode` unchanged as an original copy.
    # pylint: disable=line-too-long
    _raw_bytecode: HexStr | None = HexStr("0x")

    def __init__(self, address: ChecksumAddress | None = None) -> None:
        # Initialize parent Contract class
        super().__init__(address=address)
        self.functions = IERC721ErrorsContractFunctions(ierc721errors_abi, self.w3, address)  # type: ignore

        self.errors = IERC721ErrorsContractErrors()

    errors: IERC721ErrorsContractErrors = IERC721ErrorsContractErrors()

    functions: IERC721ErrorsContractFunctions

    @classmethod
    def constructor(cls) -> ContractConstructor:  # type: ignore
        """Creates a transaction with the contract's constructor function.

        Parameters
        ----------

        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.

        """
        cls.bytecode = cls._raw_bytecode
        if cls.bytecode is not None:

            # bytecode needs to be in hex for web3
            cls.bytecode = HexBytes(cls.bytecode)

        return super().constructor()

    @classmethod
    def deploy(cls, w3: Web3, account: LocalAccount | ChecksumAddress) -> Self:
        """Deploys an instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        deployer = cls.factory(w3=w3)
        constructor_fn = deployer.constructor()

        # if an address is supplied, try to use a web3 default account
        if isinstance(account, str):
            tx_hash = constructor_fn.transact({"from": account})
            tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

            deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
            return deployed_contract

        # otherwise use the account provided.
        deployment_tx = constructor_fn.build_transaction()
        current_nonce = w3.eth.get_transaction_count(account.address, "pending")
        deployment_tx.update({"nonce": current_nonce})

        # Sign the transaction with local account private key
        signed_tx = account.sign_transaction(deployment_tx)

        # Send the signed transaction and wait for receipt
        tx_hash = w3.eth.send_raw_transaction(signed_tx.raw_transaction)
        tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

        deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
        return deployed_contract

    @classmethod
    def factory(
        cls, w3: Web3, class_name: str | None = None, **kwargs: Any
    ) -> Type[Self]:
        """Initializes the contract object.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        class_name: str | None
            The instance class name.

        Returns
        -------
        Self
            An instance of the contract class.
        """
        contract = super().factory(w3, class_name, **kwargs)
        contract.functions = IERC721ErrorsContractFunctions(
            ierc721errors_abi, w3, None
        )
        contract.errors = IERC721ErrorsContractErrors()

        return contract
